#include "containernode.h"

// Container Node
void ContainerNode::update()
{
    for(SceneNode* sn : m_children)
        sn->update();
}

void ContainerNode::addChild(SceneNode* node)
{
    if(node != nullptr)
    {
        node->setSceneTree(m_scene);
        m_children.push_back(node);
        node->m_parent = this;
    }
}

void ContainerNode::removeChild(SceneNode* node)
{
    if(node != nullptr)
    {
        for(auto it = m_children.begin(); it != m_children.end(); ++it)
        {
            if(*it == node)
            {
                m_children.erase(it);
                node->m_parent = nullptr;
//                break;
            }
        }
    }
}

void ContainerNode::setSceneTree(SceneTree *tree)
{
    SceneNode::setSceneTree(tree);
    for(auto child : m_children)
        child->setSceneTree(tree);
}
