#ifndef MESHNODE_H
#define MESHNODE_H

#include "graphicalnode.h"
#include "glm/mat4x4.hpp"
#include "scene.h"

class btRigidBody;
class btIndexedMesh;

/**
 * @brief The MeshNode class holds a mesh
 */

class MeshNode : public GraphicalNode
{
    GeometryNode m_geometry;
    btIndexedMesh *bulletMesh;

public:
    // temp
    glm::mat4 m_movement;
    glm::mat4 m_acceleration;

    MeshNode(Mesh* mesh) : m_geometry(mesh, glm::mat4()), bulletMesh(nullptr) {}

    virtual void update();

    void setDepth(float depth);

    virtual GeometryNode* getGeometryNode() { return &m_geometry; }

    btRigidBody* buildStaticCollider();
};

#endif // MESHNODE_H
