#include "shellscrollbar.h"
#include "sparrowshell.h"
#include "mesh.h"
#include "phongmaterial.h"
#include "scene/meshnode.h"
#include "tools/utils.h"



ShellScrollBar::ShellScrollBar()
{
}

ShellScrollBar::ShellScrollBar(SparrowShell* shell):m_shell(shell){
    m_position = glm::ivec2(m_shell->getDimension().x - SparrowShell::SCROLLBAR_PIXEL_WIDTH,0);
    m_dimension = glm::ivec2(SparrowShell::SCROLLBAR_PIXEL_WIDTH,m_shell->getDimension().y);

    Mesh* mesh = new Mesh();
    mesh->addRectangle2D(glm::vec2(0),m_dimension);
    PhongMaterial *mat = new PhongMaterial();
    mat->diffuse = glm::vec3(0,0,0.5);

    mesh->setDepth(SparrowShell::SHELL_DEPTH+1);
    mesh->setMaterial(mat);
    mesh->initGL();

    m_mesh = new MeshNode(mesh);
    utils::setPosition2D(m_mesh,m_position);
    m_shell->addChild(m_mesh);
}

void ShellScrollBar::update(){
    m_position.y = m_shell->getPosition().y;
    m_dimension.y = m_shell->getDimension().y;

    float cran = ((float)m_shell->getDimension().y/(float)m_shell->getBuffer()->size());
    int indexCursor = m_shell->getBuffer()->size()-(m_shell->getIndex()+SparrowShell::BUFFER_DISPLAYED_NUMBER);
    glm::ivec2 new_pos((int)m_position.x, (int) cran * indexCursor);

    if (m_shell->isBufferResized()){
        glm::ivec2 new_dim(m_dimension.x,(int)(cran * SparrowShell::BUFFER_DISPLAYED_NUMBER));
        utils::resize2D(m_mesh,m_dimension,new_dim);
    }
    if (m_shell->isBufferResized() || m_shell->indexMoved())
        utils::setPosition2D(m_mesh,new_pos);
}
