#include "font.h"
#include <phongmaterial.h>
#include "mesh.h"
#include "scene/textnode.h"

Font::Font()
{

}

TextNode* Font::getTextNode(std::string s, glm::vec3 color, float font_size)
{

    Mesh* textmesh =  new Mesh();
    glm::vec2 current_pos(0.f);
    float sizeRatio = font_size / m_defaultLineHeight;
    for(char c : s){
        if(c == '\n')
        {
            current_pos.x = 0.f; // left alignment -> TODO : be able to center or align right
            current_pos.y += m_defaultLineHeight;
        }
        else
        {
            CharInfo charInfo = m_charTable[c];
            textmesh->addRectangle2D((current_pos + charInfo.offset)* sizeRatio,
                                     charInfo.dim * sizeRatio,
                                     charInfo.pos * m_scale,
                                     charInfo.dim * m_scale
                                     );

            current_pos.x += charInfo.xadvance;
        }
    }
    PhongMaterial *mat = new PhongMaterial();
    // TODO : delete this material somewhere (garbage collector ?)
    mat->setTexture(PhongMaterial::ALPHA_SLOT, m_tex, "font_texture");
    mat->diffuse = color;
    textmesh->setMaterial((Material*)mat);
    textmesh->initGL();
    TextNode *text = new TextNode(textmesh,s,font_size);
    return text;
}
